#ifndef FOLLOWUPSLISTMODEL_H
#define FOLLOWUPSLISTMODEL_H

#include <QObject>
#include <QAbstractTableModel>

class FollowupsListModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    explicit FollowupsListModel(int id, const QString & loginName, QObject *parent = 0);
    FollowupsListModel(QObject *parent = 0);
    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    int columnCount(const QModelIndex &parent = QModelIndex()) const;
    QVariant data(const QModelIndex &index, int role) const;
    void setupModel(const QList<QVariant> & rows);
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
    int ticketId();

    void addFollowup(const QVariant & date, const QString & text);

private:
    QList<QVariant> rows;
    int parentTicketId;
    QString loginName;
};

#endif // FOLLOWUPSLISTMODEL_H
