#include "plasmanotify.h"

PlasmaNotify::PlasmaNotify(const QString & fromApp, const QString & title, const QString & text, const QString & imagePath, const int timeout, QObject *parent):QObject(parent), fromApp(fromApp),title(title),text(text),imagePath(imagePath),timeout(timeout)
{

}

bool PlasmaNotify::send()
{
    QDBusConnection connection = QDBusConnection::connectToBus(QDBusConnection::SessionBus, "org.kde.plasma-desktop");
    if (!connection.isConnected())
        return false;

    QDBusMessage msg = QDBusMessage::createMethodCall("org.kde.plasma-desktop", "/org/freedesktop/Notifications", "org.freedesktop.Notifications", "Notify");
    QList<QVariant> args;
    QVariantMap hints;

    getImage(&hints, this->imagePath);

    args.append(this->fromApp);
    args.append(QVariant().fromValue((unsigned int) 0));
    args.append(""); //иконка
    args.append(this->title);
    args.append(this->text);
    args.append(QVariant(QStringList()));
    args.append(QVariant(hints));
    args.append(this->timeout);
    msg.setArguments(args);

    bool res = connection.send(msg);

    return res;
}

void PlasmaNotify::getImage(QVariantMap *hints,const QString & path){
    QImage img(path);
    if(img.isNull())return;
    iiibiiay i(&img);
    hints->insert("icon_data",QVariant(iiibiiay::id,&i));
}

iiibiiay::iiibiiay(QImage* img){
       if(img->format()!=QImage::Format_ARGB32)
        *img=img->convertToFormat(QImage::Format_ARGB32);
    width=img->width();
    height=img->height();
    rowstride=img->bytesPerLine();
    hasAlpha=img->hasAlphaChannel();
    channels =img->isGrayscale()?1:hasAlpha?4:3;
    bitsPerSample=img->depth()/channels;
    image.append((char*)img->rgbSwapped().bits(),img->numBytes());
}
iiibiiay::iiibiiay(){}
const int iiibiiay::id(qDBusRegisterMetaType<iiibiiay>());

QDBusArgument &operator<<(QDBusArgument &a, const iiibiiay &i) {
    a.beginStructure();
    a << i.width<<i.height<<i.rowstride<<i.hasAlpha<<i.bitsPerSample<<i.channels<<i.image;
    a.endStructure();
    return a;
}

const QDBusArgument & operator >>(const QDBusArgument &a,  iiibiiay &i) {
    a.beginStructure();
    a >> i.width>> i.height>> i.rowstride>> i.hasAlpha>> i.bitsPerSample>> i.channels>> i.image;
    a.endStructure();
    return a;
}
