#ifndef PLASMANOTIFY_H
#define PLASMANOTIFY_H

#include <QObject>
#include <QString>
#include <QImage>
#include <QBuffer>
#include <QtDBus>

struct iiibiiay{
    iiibiiay(QImage* img);
    iiibiiay();
    static const int id;
    int width;
    int height;
    int rowstride;
    bool hasAlpha;
    int bitsPerSample;
    int channels;
    QByteArray image;
};

Q_DECLARE_METATYPE(iiibiiay);

QDBusArgument &operator<<(QDBusArgument &a, const iiibiiay &i);
const QDBusArgument & operator >>(const QDBusArgument &a,  iiibiiay &i) ;

class PlasmaNotify : public QObject
{
    Q_OBJECT
public:
    explicit PlasmaNotify(const QString & fromApp, const QString & title, const QString & text, const QString & imagePath, const int timeout = 0, QObject *parent = 0);
    bool send();

private:
    QString fromApp;
    QString title;
    QString text;
    QString imagePath;
    int timeout;

    void getImage(QVariantMap *hints, const QString & imagePath);
};

#endif // PLASMANOTIFY_H
