#include "requestlistdelegate.h"
#include <QLabel>
#include <QPainter>
#include <QStylePainter>
#include <QRect>

RequestListDelegate::RequestListDelegate(QObject *parent) :
    QStyledItemDelegate(parent)
{
}

void RequestListDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    if ( index.isValid() ) {
        // Current value text
        QString valueString = index.model()->data(index, Qt::DisplayRole).toString();
        QStyleOptionViewItem option_new = option;

        //curRect = metrics.boundingRect(curRect, Qt::TextWordWrap | Qt::TextSingleLine, text);

        switch(index.column())
        {
            case 0 : {
                option_new.rect.setWidth(option.rect.width()-10);
                QStyledItemDelegate::paint(painter, option_new, index);
                break;
            }
            case 1 : {
                option_new.rect.setX(option.rect.x()+10);
                painter->drawText(option_new.rect, Qt::AlignLeft | Qt::AlignTop | Qt::TextWordWrap, valueString);
                break;
            }

            default:{
                option_new.rect.setX(option.rect.x()+10);
                QStyledItemDelegate::paint(painter, option_new, index);
                break;
            }
        }
    }
    else
    {
        QStyledItemDelegate::paint(painter, option, index);
    }
}

QSize RequestListDelegate::sizeHint ( const QStyleOptionViewItem & option, const QModelIndex & index ) const
{
    QSize size = QStyledItemDelegate::sizeHint(option, index);
    size.setWidth(size.width()+20);
    return size;
}
